(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', './api', './api/decorator', './api/main', './store', './container', './lib/children', './subscribe', './tree_viewer', './lib/decorator_factory'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('./api'), require('./api/decorator'), require('./api/main'), require('./store'), require('./container'), require('./lib/children'), require('./subscribe'), require('./tree_viewer'), require('./lib/decorator_factory'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.api, global.decorator, global.main, global.store, global.container, global.children, global.subscribe, global.tree_viewer, global.decorator_factory);
    global.index = mod.exports;
  }
})(this, function (exports, _api, _decorator, _main, _store, _container, _children, _subscribe, _tree_viewer, _decorator_factory) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  Object.defineProperty(exports, 'Api', {
    enumerable: true,
    get: function () {
      return _interopRequireDefault(_api).default;
    }
  });
  Object.defineProperty(exports, 'apiDecorator', {
    enumerable: true,
    get: function () {
      return _interopRequireDefault(_decorator).default;
    }
  });
  Object.defineProperty(exports, 'createActions', {
    enumerable: true,
    get: function () {
      return _interopRequireDefault(_main).default;
    }
  });
  Object.defineProperty(exports, 'store', {
    enumerable: true,
    get: function () {
      return _interopRequireDefault(_store).default;
    }
  });
  Object.defineProperty(exports, 'container', {
    enumerable: true,
    get: function () {
      return _interopRequireDefault(_container).default;
    }
  });
  Object.defineProperty(exports, 'Children', {
    enumerable: true,
    get: function () {
      return _children.Children;
    }
  });
  Object.defineProperty(exports, 'localState', {
    enumerable: true,
    get: function () {
      return _subscribe.localState;
    }
  });
  Object.defineProperty(exports, 'globalState', {
    enumerable: true,
    get: function () {
      return _subscribe.globalState;
    }
  });
  Object.defineProperty(exports, 'TreeViewer', {
    enumerable: true,
    get: function () {
      return _interopRequireDefault(_tree_viewer).default;
    }
  });
  Object.defineProperty(exports, 'createDecorator', {
    enumerable: true,
    get: function () {
      return _interopRequireDefault(_decorator_factory).default;
    }
  });

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }
});